﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

namespace CoreDatabase.Migrations
{
    public partial class RemLecturerPost : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_Lecturers_LecturerPosts_LecturerPostId",
                table: "Lecturers");

            migrationBuilder.DropTable(
                name: "EmployeeEmployeePosts");

            migrationBuilder.DropTable(
                name: "LecturerEmployeePosts");

            migrationBuilder.DropIndex(
                name: "IX_Lecturers_LecturerPostId",
                table: "Lecturers");

            migrationBuilder.DropIndex(
                name: "IX_LecturerPosts_LecturerPostName",
                table: "LecturerPosts");

            migrationBuilder.DropIndex(
                name: "IX_EmployeePosts_EmployeePostName",
                table: "EmployeePosts");

            migrationBuilder.DropColumn(
                name: "Hours",
                table: "LecturerPosts");

            migrationBuilder.DropColumn(
                name: "LecturerPostName",
                table: "LecturerPosts");

            migrationBuilder.DropColumn(
                name: "Order",
                table: "LecturerPosts");

            migrationBuilder.DropColumn(
                name: "EmployeePostName",
                table: "EmployeePosts");

            migrationBuilder.DropColumn(
                name: "Order",
                table: "EmployeePosts");

            migrationBuilder.AddColumn<bool>(
                name: "IsExternalCombination",
                table: "LecturerPosts",
                type: "bit",
                nullable: false,
                defaultValue: false);

            migrationBuilder.AddColumn<bool>(
                name: "IsInternalCombination",
                table: "LecturerPosts",
                type: "bit",
                nullable: false,
                defaultValue: false);

            migrationBuilder.AddColumn<Guid>(
                name: "LecturerId",
                table: "LecturerPosts",
                type: "uniqueidentifier",
                nullable: false,
                defaultValue: new Guid("00000000-0000-0000-0000-000000000000"));

            migrationBuilder.AddColumn<Guid>(
                name: "PostId",
                table: "LecturerPosts",
                type: "uniqueidentifier",
                nullable: false,
                defaultValue: new Guid("00000000-0000-0000-0000-000000000000"));

            migrationBuilder.AddColumn<decimal>(
                name: "Rate",
                table: "LecturerPosts",
                type: "decimal(18,2)",
                nullable: false,
                defaultValue: 0m);

            migrationBuilder.AddColumn<Guid>(
                name: "EmployeeId",
                table: "EmployeePosts",
                type: "uniqueidentifier",
                nullable: false,
                defaultValue: new Guid("00000000-0000-0000-0000-000000000000"));

            migrationBuilder.AddColumn<bool>(
                name: "IsExternalCombination",
                table: "EmployeePosts",
                type: "bit",
                nullable: false,
                defaultValue: false);

            migrationBuilder.AddColumn<bool>(
                name: "IsInternalCombination",
                table: "EmployeePosts",
                type: "bit",
                nullable: false,
                defaultValue: false);

            migrationBuilder.AddColumn<Guid>(
                name: "PostId",
                table: "EmployeePosts",
                type: "uniqueidentifier",
                nullable: false,
                defaultValue: new Guid("00000000-0000-0000-0000-000000000000"));

            migrationBuilder.AddColumn<decimal>(
                name: "Rate",
                table: "EmployeePosts",
                type: "decimal(18,2)",
                nullable: false,
                defaultValue: 0m);

            migrationBuilder.CreateTable(
                name: "Posts",
                columns: table => new
                {
                    Id = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    PostName = table.Column<string>(type: "nvarchar(450)", nullable: true),
                    Hours = table.Column<int>(type: "int", nullable: true),
                    Order = table.Column<int>(type: "int", nullable: false),
                    DateCreate = table.Column<DateTime>(type: "datetime2", nullable: false),
                    DateDelete = table.Column<DateTime>(type: "datetime2", nullable: true),
                    IsDeleted = table.Column<bool>(type: "bit", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Posts", x => x.Id);
                });

            migrationBuilder.CreateIndex(
                name: "IX_LecturerPosts_LecturerId",
                table: "LecturerPosts",
                column: "LecturerId");

            migrationBuilder.CreateIndex(
                name: "IX_LecturerPosts_PostId",
                table: "LecturerPosts",
                column: "PostId");

            migrationBuilder.CreateIndex(
                name: "IX_EmployeePosts_EmployeeId",
                table: "EmployeePosts",
                column: "EmployeeId");

            migrationBuilder.CreateIndex(
                name: "IX_EmployeePosts_PostId",
                table: "EmployeePosts",
                column: "PostId");

            migrationBuilder.CreateIndex(
                name: "IX_Posts_PostName",
                table: "Posts",
                column: "PostName",
                unique: true,
                filter: "[PostName] IS NOT NULL");

            migrationBuilder.AddForeignKey(
                name: "FK_EmployeePosts_Employees_EmployeeId",
                table: "EmployeePosts",
                column: "EmployeeId",
                principalTable: "Employees",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_EmployeePosts_Posts_PostId",
                table: "EmployeePosts",
                column: "PostId",
                principalTable: "Posts",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_LecturerPosts_Lecturers_LecturerId",
                table: "LecturerPosts",
                column: "LecturerId",
                principalTable: "Lecturers",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_LecturerPosts_Posts_PostId",
                table: "LecturerPosts",
                column: "PostId",
                principalTable: "Posts",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_EmployeePosts_Employees_EmployeeId",
                table: "EmployeePosts");

            migrationBuilder.DropForeignKey(
                name: "FK_EmployeePosts_Posts_PostId",
                table: "EmployeePosts");

            migrationBuilder.DropForeignKey(
                name: "FK_LecturerPosts_Lecturers_LecturerId",
                table: "LecturerPosts");

            migrationBuilder.DropForeignKey(
                name: "FK_LecturerPosts_Posts_PostId",
                table: "LecturerPosts");

            migrationBuilder.DropTable(
                name: "Posts");

            migrationBuilder.DropIndex(
                name: "IX_LecturerPosts_LecturerId",
                table: "LecturerPosts");

            migrationBuilder.DropIndex(
                name: "IX_LecturerPosts_PostId",
                table: "LecturerPosts");

            migrationBuilder.DropIndex(
                name: "IX_EmployeePosts_EmployeeId",
                table: "EmployeePosts");

            migrationBuilder.DropIndex(
                name: "IX_EmployeePosts_PostId",
                table: "EmployeePosts");

            migrationBuilder.DropColumn(
                name: "IsExternalCombination",
                table: "LecturerPosts");

            migrationBuilder.DropColumn(
                name: "IsInternalCombination",
                table: "LecturerPosts");

            migrationBuilder.DropColumn(
                name: "LecturerId",
                table: "LecturerPosts");

            migrationBuilder.DropColumn(
                name: "PostId",
                table: "LecturerPosts");

            migrationBuilder.DropColumn(
                name: "Rate",
                table: "LecturerPosts");

            migrationBuilder.DropColumn(
                name: "EmployeeId",
                table: "EmployeePosts");

            migrationBuilder.DropColumn(
                name: "IsExternalCombination",
                table: "EmployeePosts");

            migrationBuilder.DropColumn(
                name: "IsInternalCombination",
                table: "EmployeePosts");

            migrationBuilder.DropColumn(
                name: "PostId",
                table: "EmployeePosts");

            migrationBuilder.DropColumn(
                name: "Rate",
                table: "EmployeePosts");

            migrationBuilder.AddColumn<int>(
                name: "Hours",
                table: "LecturerPosts",
                type: "int",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<string>(
                name: "LecturerPostName",
                table: "LecturerPosts",
                type: "nvarchar(450)",
                nullable: false,
                defaultValue: "");

            migrationBuilder.AddColumn<int>(
                name: "Order",
                table: "LecturerPosts",
                type: "int",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<string>(
                name: "EmployeePostName",
                table: "EmployeePosts",
                type: "nvarchar(450)",
                nullable: true);

            migrationBuilder.AddColumn<int>(
                name: "Order",
                table: "EmployeePosts",
                type: "int",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.CreateTable(
                name: "EmployeeEmployeePosts",
                columns: table => new
                {
                    Id = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    DateCreate = table.Column<DateTime>(type: "datetime2", nullable: false),
                    DateDelete = table.Column<DateTime>(type: "datetime2", nullable: true),
                    EmployeeId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    EmployeePostId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    IsDeleted = table.Column<bool>(type: "bit", nullable: false),
                    IsExternalCombination = table.Column<bool>(type: "bit", nullable: false),
                    IsInternalCombination = table.Column<bool>(type: "bit", nullable: false),
                    Rate = table.Column<decimal>(type: "decimal(18,2)", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_EmployeeEmployeePosts", x => x.Id);
                    table.ForeignKey(
                        name: "FK_EmployeeEmployeePosts_EmployeePosts_EmployeePostId",
                        column: x => x.EmployeePostId,
                        principalTable: "EmployeePosts",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_EmployeeEmployeePosts_Employees_EmployeeId",
                        column: x => x.EmployeeId,
                        principalTable: "Employees",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "LecturerEmployeePosts",
                columns: table => new
                {
                    Id = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    DateCreate = table.Column<DateTime>(type: "datetime2", nullable: false),
                    DateDelete = table.Column<DateTime>(type: "datetime2", nullable: true),
                    EmployeePostId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    IsDeleted = table.Column<bool>(type: "bit", nullable: false),
                    IsExternalCombination = table.Column<bool>(type: "bit", nullable: false),
                    IsInternalCombination = table.Column<bool>(type: "bit", nullable: false),
                    LecturerId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    Rate = table.Column<decimal>(type: "decimal(18,2)", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_LecturerEmployeePosts", x => x.Id);
                    table.ForeignKey(
                        name: "FK_LecturerEmployeePosts_EmployeePosts_EmployeePostId",
                        column: x => x.EmployeePostId,
                        principalTable: "EmployeePosts",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_LecturerEmployeePosts_Lecturers_LecturerId",
                        column: x => x.LecturerId,
                        principalTable: "Lecturers",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_Lecturers_LecturerPostId",
                table: "Lecturers",
                column: "LecturerPostId");

            migrationBuilder.CreateIndex(
                name: "IX_LecturerPosts_LecturerPostName",
                table: "LecturerPosts",
                column: "LecturerPostName",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_EmployeePosts_EmployeePostName",
                table: "EmployeePosts",
                column: "EmployeePostName",
                unique: true,
                filter: "[EmployeePostName] IS NOT NULL");

            migrationBuilder.CreateIndex(
                name: "IX_EmployeeEmployeePosts_EmployeeId",
                table: "EmployeeEmployeePosts",
                column: "EmployeeId");

            migrationBuilder.CreateIndex(
                name: "IX_EmployeeEmployeePosts_EmployeePostId",
                table: "EmployeeEmployeePosts",
                column: "EmployeePostId");

            migrationBuilder.CreateIndex(
                name: "IX_LecturerEmployeePosts_EmployeePostId",
                table: "LecturerEmployeePosts",
                column: "EmployeePostId");

            migrationBuilder.CreateIndex(
                name: "IX_LecturerEmployeePosts_LecturerId",
                table: "LecturerEmployeePosts",
                column: "LecturerId");

            migrationBuilder.AddForeignKey(
                name: "FK_Lecturers_LecturerPosts_LecturerPostId",
                table: "Lecturers",
                column: "LecturerPostId",
                principalTable: "LecturerPosts",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
