﻿using CoreModels.ModelsDepartment;
using ToolsModule.Interfaces;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Runtime.Serialization;

namespace CoreDatabase.Models.Department
{
    /// <summary>
    /// Класс, описывающий дисципилну кафедры
    /// </summary>
    [DataContract]
	public class Discipline : BaseEntity, IEntitySecurityExtenstion<Discipline>, IDisciplineModel
    {
        [DataMember]
        [Required(ErrorMessage = "required")]
        public Guid DisciplineBlockId { get; set; }

        [DataMember]
        [Required(ErrorMessage = "required")]
        public string DisciplineName { get; set; }

        [DataMember]
        public string DisciplineShortName { get; set; }

        [DataMember]
        public string Description { get; set; }

        public string DisciplineBlueAsteriskName { get; set; }

		//-------------------------------------------------------------------------

		public virtual DisciplineBlock DisciplineBlock { get; set; }

        //-------------------------------------------------------------------------

        [ForeignKey("DisciplineId")]
        public virtual List<AcademicPlanRecord> AcademicPlanRecords { get; set; }

        //-------------------------------------------------------------------------

        public Discipline SecurityCheck(Discipline entity, bool allowFullData) => entity;

        public override string ToString() => DisciplineName;
    }
}