﻿using CoreModels.Enums.Department;
using CoreModels.ModelsDepartment;
using ToolsModule.Interfaces;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Runtime.Serialization;

namespace CoreDatabase.Models.Department
{
    /// <summary>
    /// Класс, описывающий направление обучения кафедры
    /// </summary>
    [DataContract]
	public class EducationDirection : BaseEntity, IEntitySecurityExtenstion<EducationDirection>, IEducationDirectionModel
    {
		[DataMember]
        [Required(ErrorMessage = "required")]
        public string Cipher { get; set; }

        [DataMember]
        [Required(ErrorMessage = "required")]
        public string ShortName { get; set; }

        [DataMember]
        [Required(ErrorMessage = "required")]
        public string Title { get; set; }

        public string Profile { get; set; }

        [DataMember]
        [Required(ErrorMessage = "required")]
        public EducationDirectionQualification Qualification { get; set; }

        [DataMember]
        [Required(ErrorMessage = "required")]
        public Guid LecturerId { get; set; }

        public string Description { get; set; }

        //-------------------------------------------------------------------------

        public virtual Lecturer Lecturer { get; set; }

        //-------------------------------------------------------------------------

        [ForeignKey("EducationDirectionId")]
        public virtual List<AcademicPlan> AcademicPlans { get; set; }

        [ForeignKey("EducationDirectionId")]
        public virtual List<StudentGroup> StudentGroups { get; set; }

        //-------------------------------------------------------------------------

        public EducationDirection SecurityCheck(EducationDirection entity, bool allowFullData) => entity;

        public override string ToString() => $"{Cipher} {ShortName}({Profile})";
    }
}