﻿using CoreModels.ModelsDepartment;
using ToolsModule.Interfaces;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Runtime.Serialization;

namespace CoreDatabase.Models.Department
{
    [DataContract]
	public class LecturerAcademicDegree : BaseEntity, IEntitySecurityExtenstion<LecturerAcademicDegree>, ILecturerAcademicDegreeModel
	{
		[DataMember]
		[Required]
		public string LecturerAcademicDegreeName { get; set; }

		[DataMember]
		public string Description { get; set; }

		[DataMember]
		public int Order { get; set; }

		//-------------------------------------------------------------------------

		//-------------------------------------------------------------------------

		[ForeignKey("LecturerAcademicDegreeId")]
		public virtual List<Lecturer> Lecturers { get; set; }

		//-------------------------------------------------------------------------

		public LecturerAcademicDegree SecurityCheck(LecturerAcademicDegree entity, bool allowFullData) => entity;

		public override string ToString() => LecturerAcademicDegreeName;
	}
}