﻿using CoreModels.Enums.Department;
using CoreModels.ModelsDepartment;
using ToolsModule.Interfaces;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Runtime.Serialization;

namespace CoreDatabase.Models.Department
{
    [DataContract]
	public class Order : BaseEntity, IEntitySecurityExtenstion<Order>, IOrderModel
	{
		[DataMember]
		[Required(ErrorMessage = "required")]
		public string OrderNumber { get; set; }

		[DataMember]
		[Required(ErrorMessage = "required")]
		public DateTime OrderDate { get; set; }

		[DataMember]
		[Required(ErrorMessage = "required")]
		public OrderType OrderType { get; set; }

		//-------------------------------------------------------------------------

		//-------------------------------------------------------------------------

		[ForeignKey("OrderId")]
		public virtual List<OrderStudentRecord> OrderStudentRecords { get; set; }

		//-------------------------------------------------------------------------

		public Order SecurityCheck(Order entity, bool allowFullData) => entity;

		public override string ToString() => $"№{OrderNumber} от {OrderDate.ToShortDateString()}";
	}
}