﻿using CoreModels.Enums.Department;
using CoreModels.ModelsDepartment;
using CoreDatabase.Models.Security;
using ToolsModule.Extensions;
using ToolsModule.Interfaces;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Runtime.Serialization;

namespace CoreDatabase.Models.Department
{
    [DataContract]
	public class Student : BaseEntity, IEntitySecurityExtenstion<Student>, IStudentModel
    {
        [DataMember]
        [Required]
        public Guid UserId { get; set; }

        [DataMember]
        public Guid? StudentGroupId { get; set; }

        [DataMember]
        [Required]
        public string Iduniv { get; set; }

        [DataMember]
        [Required]
        public string NumberOfBook { get; set; }

        [DataMember]
        [Required]
        public string LastName { get; set; }

        [DataMember]
        [Required]
        public string FirstName { get; set; }

        [DataMember]
        public string Patronymic { get; set; }

        [DataMember]
        public string Email { get; set; }

        [DataMember]
        public string Description { get; set; }

        [Required(ErrorMessage = "required")]
        public StudentState StudentState { get; set; }

        [DataMember]
        public byte[] Photo { get; set; }

        [DataMember]
        public bool IsSteward { get; set; }

        //-------------------------------------------------------------------------

        public virtual User User { get; set; }

        public virtual StudentGroup StudentGroup { get; set; }

        //-------------------------------------------------------------------------

        [ForeignKey("StudentId")]
        public virtual List<OrderStudentRecord> OrderStudentRecords { get; set; }

        //-------------------------------------------------------------------------

        public Student SecurityCheck(Student entity, bool allowFullData)
        {
            if (!allowFullData)
            {
                entity.NumberOfBook = Guid.NewGuid().ToString();
                entity.Email = "скрыто";
                entity.Photo = null;
            }

            return entity;
        }

        public override string ToString() =>
            $"{LastName}{(FirstName.IsNotEmpty() ? $" {FirstName[0]}." : string.Empty)}{(Patronymic.IsNotEmpty() ? $"{Patronymic[0]}." : string.Empty)}";
    }
}