﻿using CoreModels.Enums.Department;
using CoreModels.ModelsDepartment;
using ToolsModule.Interfaces;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Runtime.Serialization;

namespace CoreDatabase.Models.Department
{
    [DataContract]
	public class StudentGroup : BaseEntity, IEntitySecurityExtenstion<StudentGroup>, IStudentGroupModel
	{
		[DataMember]
		[Required(ErrorMessage = "required")]
		public Guid EducationDirectionId { get; set; }

		[DataMember]
		[Required(ErrorMessage = "required")]
		public int GroupNumber { get; set; }

		[DataMember]
		[Required(ErrorMessage = "required")]
		public AcademicCourse AcademicCourse { get; set; }

		[DataMember]
		public Guid? LecturerId { get; set; }

		//-------------------------------------------------------------------------

		public virtual EducationDirection EducationDirection { get; set; }

		public virtual Lecturer Lecturer { get; set; }

		//-------------------------------------------------------------------------

		[ForeignKey("StudentGroupId")]
		public virtual List<Student> Students { get; set; }

		[ForeignKey("StudentGroupFromId")]
		public virtual List<OrderStudentRecord> OrderStudentRecordFroms { get; set; }

		[ForeignKey("StudentGroupToId")]
		public virtual List<OrderStudentRecord> OrderStudentRecordTos { get; set; }

		//-------------------------------------------------------------------------

		public StudentGroup SecurityCheck(StudentGroup entity, bool allowFullData) => entity;

		public override string ToString() => $"{EducationDirection?.ShortName}-{AcademicCourse}{GroupNumber}";

		public int GetStudnetsByState(StudentState state)
        {
			return Students?.Where(x => x.StudentState == state)?.Count() ?? 0;
        }
	}
}