﻿using CoreModels.ModelsSecurity;
using ToolsModule.Interfaces;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Runtime.Serialization;

namespace CoreDatabase.Models.Security
{
    [DataContract]
    public class Role : BaseEntity, IEntitySecurityExtenstion<Role>, IRoleModel
    {
        [DataMember]
        [Required]
        public string RoleName { get; set; }

        [DataMember]
        public int RolePriority { get; set; }

        //-------------------------------------------------------------------------

        //-------------------------------------------------------------------------

        [ForeignKey("RoleId")]
        public virtual List<Access> Access { get; set; }

        [ForeignKey("RoleId")]
        public virtual List<UserRole> UserRoles { get; set; }

        //-------------------------------------------------------------------------

        public Role SecurityCheck(Role entity, bool allowFullData) => entity;

        public override string ToString() => RoleName;

    }
}