﻿namespace CoreModels.Enums.Department
{
    /// <summary>
    /// Типы приказов по студентам
    /// </summary>
    public enum OrderStudentMoveType
    {
        Неопределено = -1,

        /// <summary>
        /// Студент зачисляется сразу на направление кафедры
        /// </summary>
        ЗачислитьПоПриказу = 0,

        /// <summary>
        /// Распределение студента в группу
        /// </summary>
        Распределить = 1,

        /// <summary>
        /// Перевод на старший курс
        /// </summary>
        ПеревестиНаСтаршийКурс = 2,

        /// <summary>
        /// Отчисление студента в связи с завершением обучения
        /// </summary>
        ОтчислитьПоЗавершению = 3,

        /// <summary>
        /// Студент переводится с другой кафедры на нашу
        /// </summary>
        ПринятьПоПереводу = 5,

        /// <summary>
        /// Студент переводится с другого вуза на нашу кафедру
        /// </summary>
        ПринятьПоПереводусДругогоВуза = 6,

        /// <summary>
        /// Переход с одного направления кафедоры на другое
        /// </summary>
        ПеревестиНаДругоеНаправлениеКафедры = 7,

        /// <summary>
        /// Студент переводится с нашей кафедры на другую
        /// </summary>
        УбратьПоПереводу = 8,

        /// <summary>
        /// Уход в акакдем студента
        /// </summary>
        ОтправитьВАкадем = 10,

        /// <summary>
        /// Продление академа студента
        /// </summary>
        ПродлитьАкадем = 11,

        /// <summary>
        /// Выход из академа студента
        /// </summary>
        ВосстановитьИзАкадема = 12,

        /// <summary>
        /// Отчисление студента в связи с не выходом из академа
        /// </summary>
        ОтчислитьЗаНевыходСАкадема = 13,

        /// <summary>
        /// Уход студента в другой ВУЗ
        /// </summary>
        ОтчислитьВСвязиСПереводом = 20,

        /// <summary>
        /// Отчисление студента за долги
        /// </summary>
        ОтчислитьЗаНеуспевамость = 21,

        /// <summary>
        /// Отчисление студента по собственному
        /// </summary>
        ОтчислитьПоСобственному = 22,

        /// <summary>
        /// Восстановление студента после отчисления по собственному
        /// </summary>
        Восстановить = 23
    }
}