﻿using CoreModels.Enums.Department;
using CoreModels.Tools;
using ToolsModule.Attributes;
using System;

namespace CoreModels.ModelsDepartment
{
    [EntityDescription("AcademicPlanRecord", "Запись учебного плана кафедры")]
    [EntityDependency("AcademicPlan", "AcademicPlanId", "Учебный план, к которму относится запись")]
    [EntityDependency("Discipline", "DisciplineId", "Дисциплина, которая указана в записи плана")]
    public interface IAcademicPlanRecordModel : IId
    {
        Guid AcademicPlanId { get; }

        Guid DisciplineId { get; }

        Semester Semester { get; }

        int Zet { get; }

        bool InDepartment { get; }

        Guid? AcademicPlanRecordParentId { get; }

        /// <summary>
        /// Является родительской для дисциплин по выбору
        /// </summary>
        bool IsParent { get; }

        /// <summary>
        /// Является факультативной дисциплиной
        /// </summary>
        bool IsFacultative { get; }
    }
}