﻿using CoreModels.Tools;
using ToolsModule.Attributes;
using System;

namespace CoreModels.ModelsDepartment
{
	[EntityDescription("EmployeeEmployeePost", "Связь сотрудника и должность кафедры")]
	[EntityDependency("Post", "PostId", "К какой должности относится сотрудник")]
	[EntityDependency("Employee", "EmployeeId", "К какой должности относится сотрудник")]
	public interface IEmployeePostModel : IId
	{
		[CheckRigthForMap]
		Guid EmployeeId { get; }

		Guid PostId { get; }

		decimal Rate { get; }

		bool IsInternalCombination { get; }

		bool IsExternalCombination { get; }
	}
}