﻿using CoreModels.Tools;
using ToolsModule.Attributes;
using System;

namespace CoreModels.ModelsDepartment
{
    [EntityDescription("Lecturer", "Преподаваетль кафедры")]
    [EntityDependency("User", "UserId", "К какому пользователю относится преподаватель")]
    [EntityDependency("LecturerAcademicRank", "LecturerAcademicRankId", "Какое звание имеет преподаватель")]
    [EntityDependency("LecturerAcademicDegree", "LecturerAcademicDegreeId", "Какую степень имеет преподаватель")]
    public interface ILecturerModel : IId
    {
        Guid UserId { get; }

        Guid? LecturerAcademicRankId { get; }

        Guid? LecturerAcademicDegreeId { get; }

        string LastName { get; }

        string FirstName { get; }

        string Patronymic { get; }

        string Abbreviation { get; }

        [CheckRigthForMap]
        DateTime DateBirth { get; }

        [CheckRigthForMap]
        string Address { get; }

        [CheckRigthForMap]
        string Email { get; }

        [CheckRigthForMap]
        string MobileNumber { get; }

        [CheckRigthForMap]
        string HomeNumber { get; }

        string Description { get; }

        byte[] Photo { get; }

        bool OnlyForPrivate { get; }

        string GroupElectricalSafety { get; }
    }
}