﻿using CoreModels.Enums.Department;
using CoreModels.Tools;
using ToolsModule.Attributes;
using System;

namespace CoreModels.ModelsDepartment
{
    [EntityDescription("OrderStudentRecord", "Запись приказа по студенту")]
	[EntityDependency("Order", "OrderId", "Приказ, к которому относится запись")]
	[EntityDependency("Student", "StudentId", "Студент, указанный в приказе")]
	[EntityDependency("StudentGroup", "StudentGroupFromId", "Из какой группы уходит студент")]
	[EntityDependency("StudentGroup", "StudentGroupToId", "В какую группу приходит студент")]
	public interface IOrderStudentRecordModel : IId
	{
		public Guid OrderId { get; set; }

		public Guid StudentId { get; set; }

		public Guid? StudentGroupFromId { get; set; }

		public Guid? StudentGroupToId { get; set; }

		public OrderStudentMoveType OrderStudentMoveType { get; set; }

		public string Info { get; set; }
	}
}