﻿using CoreModels.Tools;
using ToolsModule.Attributes;
using ToolsModule.Enums;
using System;

namespace CoreModels.ModelsSecurity
{
    [EntityDescription("Access", "Доступные действия для ролей")]
    [EntityDependency("Role", "RoleId", "Доступные дейсвтиия создаются под конкретную роль")]
    public interface IAccessModel : IId
    {
        /// <summary>
        /// Илентификатор роли
        /// </summary>
        [CheckRigthForMap]
        Guid RoleId { get; }

        /// <summary>
        /// Тип операции
        /// </summary>
        [CheckRigthForMap]
        AccessOperation AccessOperation { get; }

        /// <summary>
        /// Режим доступа
        /// </summary>
        [CheckRigthForMap]
        AccessType AccessType { get; }
    }
}