﻿using CoreModels.Tools;
using ToolsModule.Attributes;
using System;

namespace CoreModels.ModelsSecurity
{
    /// <summary>
    /// Связка пользователь - роль
    /// </summary>
    [EntityDescription("UserRole", "Связь пользователей системы с ролями, которые им назначены")]
    [EntityDependency("Role", "RoleId", "К какой роли относится пользователь")]
    [EntityDependency("User", "UserId", "К какой роли относится пользователь")]
    public interface IUserRoleModel : IId
    {
        [CheckRigthForMap]
        Guid RoleId { get; }

        [CheckRigthForMap]
        Guid UserId { get; }
    }
}