﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

namespace CoreDatabase.Migrations
{
    public partial class AddEducationDirection : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropIndex(
                name: "IX_Classrooms_Number",
                table: "Classrooms");

            migrationBuilder.AlterColumn<string>(
                name: "Number",
                table: "Classrooms",
                type: "nvarchar(450)",
                nullable: false,
                defaultValue: "",
                oldClrType: typeof(string),
                oldType: "nvarchar(450)",
                oldNullable: true);

            migrationBuilder.CreateTable(
                name: "EducationDirections",
                columns: table => new
                {
                    Id = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    Cipher = table.Column<string>(type: "nvarchar(max)", nullable: false),
                    ShortName = table.Column<string>(type: "nvarchar(max)", nullable: false),
                    Title = table.Column<string>(type: "nvarchar(450)", nullable: false),
                    Profile = table.Column<string>(type: "nvarchar(450)", nullable: true),
                    Qualification = table.Column<string>(type: "nvarchar(max)", nullable: false),
                    LecturerId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    Description = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    DateCreate = table.Column<DateTime>(type: "datetime2", nullable: false),
                    DateDelete = table.Column<DateTime>(type: "datetime2", nullable: true),
                    IsDeleted = table.Column<bool>(type: "bit", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_EducationDirections", x => x.Id);
                    table.ForeignKey(
                        name: "FK_EducationDirections_Lecturers_LecturerId",
                        column: x => x.LecturerId,
                        principalTable: "Lecturers",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_Classrooms_Number",
                table: "Classrooms",
                column: "Number",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_EducationDirections_LecturerId",
                table: "EducationDirections",
                column: "LecturerId");

            migrationBuilder.CreateIndex(
                name: "IX_EducationDirections_Title_Profile",
                table: "EducationDirections",
                columns: new[] { "Title", "Profile" },
                unique: true,
                filter: "[Profile] IS NOT NULL");
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "EducationDirections");

            migrationBuilder.DropIndex(
                name: "IX_Classrooms_Number",
                table: "Classrooms");

            migrationBuilder.AlterColumn<string>(
                name: "Number",
                table: "Classrooms",
                type: "nvarchar(450)",
                nullable: true,
                oldClrType: typeof(string),
                oldType: "nvarchar(450)");

            migrationBuilder.CreateIndex(
                name: "IX_Classrooms_Number",
                table: "Classrooms",
                column: "Number",
                unique: true,
                filter: "[Number] IS NOT NULL");
        }
    }
}
