﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

namespace CoreDatabase.Migrations
{
    public partial class ChangeTypeInacademicPlan : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_AcademicPlanRecordTimeNormHours_TimeNorms_TimeNormId",
                table: "AcademicPlanRecordTimeNormHours");

            migrationBuilder.DropIndex(
                name: "IX_AcademicPlans_EducationDirectionId_YearEntrance",
                table: "AcademicPlans");

            migrationBuilder.DropColumn(
                name: "YearFinish",
                table: "AcademicPlans");

            migrationBuilder.DropColumn(
                name: "YearEntrance",
                table: "AcademicPlans");

            migrationBuilder.AddColumn<int>(
                name: "YearFinish",
                table: "AcademicPlans",
                type: "int",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "YearEntrance",
                table: "AcademicPlans",
                type: "int",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddForeignKey(
                name: "FK_AcademicPlanRecordTimeNormHours_TimeNorms_TimeNormId",
                table: "AcademicPlanRecordTimeNormHours",
                column: "TimeNormId",
                principalTable: "TimeNorms",
                principalColumn: "Id",
                onDelete: ReferentialAction.NoAction);

            migrationBuilder.CreateIndex(
                name: "IX_AcademicPlans_EducationDirectionId_YearEntrance",
                table: "AcademicPlans",
                columns: new[] { "EducationDirectionId", "YearEntrance" },
                unique: true);
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_AcademicPlanRecordTimeNormHours_TimeNorms_TimeNormId",
                table: "AcademicPlanRecordTimeNormHours");

            migrationBuilder.DropIndex(
                name: "IX_AcademicPlans_EducationDirectionId_YearEntrance",
                table: "AcademicPlans");

            migrationBuilder.DropColumn(
                name: "YearFinish",
                table: "AcademicPlans");

            migrationBuilder.DropColumn(
                name: "YearEntrance",
                table: "AcademicPlans");

            migrationBuilder.AddColumn<DateTime>(
                  name: "YearEntrance",
                  table: "AcademicPlans",
                  type: "datetime2",
                  nullable: false,
                  defaultValue: new DateTime(1, 1, 1, 0, 0, 0, 0, DateTimeKind.Unspecified));

            migrationBuilder.AddColumn<DateTime>(
                name: "YearFinish",
                table: "AcademicPlans",
                type: "datetime2",
                nullable: false,
                defaultValue: new DateTime(1, 1, 1, 0, 0, 0, 0, DateTimeKind.Unspecified));

            migrationBuilder.AddForeignKey(
                name: "FK_AcademicPlanRecordTimeNormHours_TimeNorms_TimeNormId",
                table: "AcademicPlanRecordTimeNormHours",
                column: "TimeNormId",
                principalTable: "TimeNorms",
                principalColumn: "Id");

            migrationBuilder.CreateIndex(
                name: "IX_AcademicPlans_EducationDirectionId_YearEntrance",
                table: "AcademicPlans",
                columns: new[] { "EducationDirectionId", "YearEntrance" },
                unique: true);
        }
    }
}
