﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

namespace CoreDatabase.Migrations
{
    public partial class AddOrderSyncHistories : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_OrderStudentRecords_StudentGroups_StudentGroupToId",
                table: "OrderStudentRecords");

            migrationBuilder.DropForeignKey(
                name: "FK_OrderStudentRecords_Students_StudentId",
                table: "OrderStudentRecords");

            migrationBuilder.CreateTable(
                name: "OrderSyncHistories",
                columns: table => new
                {
                    Id = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    SyncDate = table.Column<DateTime>(type: "datetime2", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_OrderSyncHistories", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "OrderSyncHistoryRecords",
                columns: table => new
                {
                    Id = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    OrderSyncHistoryId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    Information = table.Column<string>(type: "nvarchar(max)", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_OrderSyncHistoryRecords", x => x.Id);
                    table.ForeignKey(
                        name: "FK_OrderSyncHistoryRecords_OrderSyncHistories_OrderSyncHistoryId",
                        column: x => x.OrderSyncHistoryId,
                        principalTable: "OrderSyncHistories",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_OrderSyncHistoryRecords_OrderSyncHistoryId",
                table: "OrderSyncHistoryRecords",
                column: "OrderSyncHistoryId");

            migrationBuilder.AddForeignKey(
                name: "FK_OrderStudentRecords_StudentGroups_StudentGroupToId",
                table: "OrderStudentRecords",
                column: "StudentGroupToId",
                principalTable: "StudentGroups",
                principalColumn: "Id");

            migrationBuilder.AddForeignKey(
                name: "FK_OrderStudentRecords_Students_StudentId",
                table: "OrderStudentRecords",
                column: "StudentId",
                principalTable: "Students",
                principalColumn: "Id");
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_OrderStudentRecords_StudentGroups_StudentGroupToId",
                table: "OrderStudentRecords");

            migrationBuilder.DropForeignKey(
                name: "FK_OrderStudentRecords_Students_StudentId",
                table: "OrderStudentRecords");

            migrationBuilder.DropTable(
                name: "OrderSyncHistoryRecords");

            migrationBuilder.DropTable(
                name: "OrderSyncHistories");

            migrationBuilder.AddForeignKey(
                name: "FK_OrderStudentRecords_StudentGroups_StudentGroupToId",
                table: "OrderStudentRecords",
                column: "StudentGroupToId",
                principalTable: "StudentGroups",
                principalColumn: "Id",
                onDelete: ReferentialAction.SetNull);

            migrationBuilder.AddForeignKey(
                name: "FK_OrderStudentRecords_Students_StudentId",
                table: "OrderStudentRecords",
                column: "StudentId",
                principalTable: "Students",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
