﻿using CoreModels.ModelsDepartment;
using ToolsModule.Interfaces;
using System;
using System.Runtime.Serialization;

namespace CoreDatabase.Models.Department
{
    [DataContract]
	public class EmployeePost : BaseEntity, IEntitySecurityExtenstion<EmployeePost>, IEmployeePostModel
	{
		[DataMember]
		public Guid EmployeeId { get; set; }

		[DataMember]
		public Guid PostId { get; set; }

		[DataMember]
		public decimal Rate { get; set; }

		[DataMember]
		public bool IsInternalCombination { get; set; }

		[DataMember]
		public bool IsExternalCombination { get; set; }

		//-------------------------------------------------------------------------

		public virtual Post Post { get; set; }

		public virtual Employee Employee { get; set; }

		//-------------------------------------------------------------------------

		//-------------------------------------------------------------------------

		public EmployeePost SecurityCheck(EmployeePost entity, bool allowFullData) => entity;

		public override string ToString() => $"{Post}-{Employee}";
	}
}
