﻿using CoreModels.Enums.Department;
using CoreModels.ModelsDepartment;
using ToolsModule.Interfaces;
using System;
using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;

namespace CoreDatabase.Models.Department
{
    [DataContract]
	public class OrderStudentRecord : BaseEntity, IEntitySecurityExtenstion<OrderStudentRecord>, IOrderStudentRecordModel
	{
		[DataMember]
		[Required(ErrorMessage = "required")]
		public Guid OrderId { get; set; }

		[DataMember]
		[Required(ErrorMessage = "required")]
		public Guid StudentId { get; set; }

		[DataMember]
		public Guid? StudentGroupFromId { get; set; }

		[DataMember]
		public Guid? StudentGroupToId { get; set; }

		[DataMember]
		[Required(ErrorMessage = "required")]
		public OrderStudentMoveType OrderStudentMoveType { get; set; }

		[DataMember]
		public string Info { get; set; }

		//-------------------------------------------------------------------------

		public virtual Order Order { get; set; }

		public virtual Student Student { get; set; }

		public virtual StudentGroup StudentGroupFrom { get; set; }

		public virtual StudentGroup StudentGroupTo { get; set; }

		//-------------------------------------------------------------------------

		//-------------------------------------------------------------------------

		public OrderStudentRecord SecurityCheck(OrderStudentRecord entity, bool allowFullData)
		{
			if (!allowFullData)
			{
				entity.Info = string.Empty;
				entity.OrderStudentMoveType = 0;
			}

			return entity;
		}

		public override string ToString() => $"{Student} {OrderStudentMoveType}";
	}
}