﻿using CoreModels.Enums.Department;
using CoreModels.ModelsDepartment;
using ToolsModule.Interfaces;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Runtime.Serialization;

namespace CoreDatabase.Models.Department
{
    [DataContract]
	public class TimeNorm : BaseEntity, IEntitySecurityExtenstion<TimeNorm>, ITimeNormModel
    {
        [DataMember]
        [Required(ErrorMessage = "required")]
        public Guid DisciplineBlockId { get; set; }

        [DataMember]
        [Required(ErrorMessage = "required")]
        public string TimeNormName { get; set; }

        [DataMember]
        [Required(ErrorMessage = "required")]
        public string TimeNormShortName { get; set; }

        [DataMember]
        [Required(ErrorMessage = "required")]
        public int TimeNormOrder { get; set; }

        [DataMember]
        public EducationDirectionQualification? TimeNormEducationDirectionQualification { get; set; }

        [DataMember]
        [Required(ErrorMessage = "required")]
        public string KindOfLoadName { get; set; }

        [DataMember]
        public string KindOfLoadAttributeName { get; set; }

        [DataMember]
        public string KindOfLoadBlueAsteriskName { get; set; }

        [DataMember]
        public string KindOfLoadBlueAsteriskAttributeName { get; set; }

        [DataMember]
        public string KindOfLoadBlueAsteriskPracticName { get; set; }

        [DataMember]
        public bool UseInLearningProgress { get; set; }

        [DataMember]
        public bool UseInSite { get; set; }

        //-------------------------------------------------------------------------

        public virtual DisciplineBlock DisciplineBlock { get; set; }

        //-------------------------------------------------------------------------

        [ForeignKey("TimeNormId")]
        public virtual List<AcademicPlanRecordTimeNormHour> AcademicPlanRecordTimeNormHours { get; set; }

        //-------------------------------------------------------------------------

        public TimeNorm SecurityCheck(TimeNorm entity, bool allowFullData) => entity;

        public override string ToString() => TimeNormName;
    }
}