﻿using ToolsDesktop.Models;

namespace ToolsDesktop.Interfaces
{
	/// <summary>
	/// Работа с контролом элемента
	/// </summary>
	public interface IControlViewEntityElement
	{
		/// <summary>
		/// Открытие формы
		/// </summary>
		/// <param name="model"></param>
		void OpenControl(ControlOpenModel model);

		/// <summary>
		/// Новый экземпляр контрола
		/// </summary>
		/// <returns></returns>
		IControl GetInstanceControl();

		/// <summary>
		/// Сохранение настроек в xml-строку
		/// </summary>
		/// <returns></returns>
		string SaveControlToXml();

		/// <summary>
		/// Загрузка настроек из xml-строки
		/// </summary>
		/// <param name="xml"></param>
		void LoadControlFromXml(string xml);
	}
}