﻿using ToolsDesktop.Models;
using System.Collections.Generic;

namespace ToolsDesktop.Interfaces
{
	/// <summary>
	/// Интерфейс для регистрации контролов для десктопного приложения
	/// </summary>
	public interface IWindowDesktopExtension
	{
		/// <summary>
		/// Получение списка контролов модуля для работсы с сущностями, доступных для работы по авторизованному пользователю 
		/// </summary>
		/// <returns></returns>
		List<WindowDesktopExtensionControlModel> GetListControlEntityList();

		/// <summary>
		/// Получение списка контролов модуля для особой работы, доступных для работы по авторизованному пользователю 
		/// </summary>
		/// <returns></returns>
		List<WindowDesktopExtensionControlModel> GetListControlSpecialList();
	}
}