﻿using ToolsDesktop.Enums;
using System;

namespace ToolsDesktop.Models
{
	/// <summary>
	/// Данные, передаваемый при открытии контрола
	/// </summary>
	public class ControlOpenModel
	{
		/// <summary>
		/// Варинат открытия контрола списка
		/// </summary>
		public ControlOpenMode OpenMode { get; set; }

		/// <summary>
		/// Не загружать данные
		/// </summary>
		public bool LazyLoading { get; set; } = false;

		/// <summary>
		/// Событипе на закрытие контрола списка, если открыт как список
		/// </summary>
		public Action<Guid> CloseList { get; set; }

		/// <summary>
		/// Событипе на закрытие контрола списка, если открыт на выбор
		/// </summary>
		public Action<bool> CloseSelect { get; set; }

		/// <summary>
		/// Событипе на закрытие контрола Элемента
		/// </summary>
		public Action<Guid> CloseElement { get; set; }

		/// <summary>
		/// Идентификатор выбранной записи для контрола элемента
		/// </summary>
		public Guid? ElementId { get; set; }
	}
}