﻿using ToolsDesktop.Enums;
using System;
using System.Collections.Generic;

namespace ToolsDesktop.Models
{
	/// <summary>
	/// Настройки для контрола вывода списка записей сущности
	/// </summary>
	public class ControlViewEntityListConfiguration
	{
		/// <summary>
		/// Тип класса, который будет выводится
		/// </summary>
		public Type EntityType { get; set; }

		/// <summary>
		/// Список названий кнопок, которые надо скрыть
		/// </summary>
		public List<ToolStripButtonListNames> HideToolStripButton { get; set; }

		/// <summary>
		/// Перечень действий для контектснго меню и выпадающего в верхнем меню пункта "Действия"
		/// </summary>
		public Dictionary<string, (string Title, EventHandler Event)> ControlOnMoveElem { get; set; } = null;

		/// <summary>
		/// Есть пагинация
		/// </summary>
		public bool PaginationOn { get; set; } = true;

		/// <summary>
		/// Перечень значений для выбора при выводе пагинации по названиям
		/// </summary>
		public List<PageNamesForPaginationModel> PageNamesForPagination { get; set; } = null;

		/// <summary>
		/// Название свойства в дочернем классе
		/// </summary>
		public string ParentPropertyName { get; set; }

		/// <summary>
		/// Количество записей на странице (для пагинации)
		/// </summary>
		public int? CountElementsOnPage { get; set; } = null;
	}
}