﻿using System;

namespace ToolsModule.Attributes
{
	/// <summary>
	/// Настройка контрола отображения? указывающая на дочерний контрол (требуется для автоматизации вывода элемента, 
	/// применяется к классам ElementViewModel)
	/// </summary>
	[AttributeUsage(AttributeTargets.Class, AllowMultiple = true)]
	public class ViewModelControlElementDependenceEntityAttribute : Attribute
	{
		/// <summary>
		/// Заголовок вкладки
		/// </summary>
		public string Title { get; set; }

		/// <summary>
		/// Порядок вкладки
		/// </summary>
		public int Order { get; set; } = 0;

		/// <summary>
		/// При открытии элемента отображать с этой вкладки
		/// </summary>
		public bool IsActive { get; set; } = false;

		/// <summary>
		/// Имя контрола (включая namespace) для вставки контрола во вкладку
		/// </summary>
		public string ControlTypeObject { get; set; } = string.Empty;

		/// <summary>
		/// Название свойства в дочернем классе, по которму идет связь
		/// </summary>
		public string ParentPropertyName { get; set; } = string.Empty;
	}
}