﻿using System;

namespace ToolsModule.BindingModels
{
	/// <summary>
	/// Получение записи
	/// </summary>
	public class GetBindingModel : AccessBindingModel
	{
		/// <summary>
		/// Наличие прав на операцию
		/// </summary>
		public bool HaveRight { get; set; }

		/// <summary>
		/// Идентификатор получаемой записи (для одной записи)
		/// </summary>
		public Guid? Id { get; set; }

		/// <summary>
		/// Номер страницы, которую получаем (для списка)
		/// </summary>
		public int? PageNumber { get; set; }

		/// <summary>
		/// Количество записей возвращаемых (для списка)
		/// </summary>
		public int? PageSize { get; set; }

		/// <summary>
		/// Иной признак, по которму отбираем записи (для списка)
		/// </summary>
		public string PageName { get; set; }
	}
}