﻿namespace ToolsModule.Enums
{
	/// <summary>
	/// Тип контрола, через который следует отображать свойство с ViewModel
	/// </summary>
	public enum ControlType
	{
		/// <summary>
		/// Простое однострочное текстовое поле
		/// </summary>
		ControlString = 0,

		/// <summary>
		/// Текстовое поле в несколько строк
		/// </summary>
		ControlText = 1,
		
		/// <summary>
		/// Поле для целочисленного значения
		/// </summary>
		ControlInt = 2,

		/// <summary>
		/// Поле для вещественного значения
		/// </summary>
		ControlDecimal = 3,

		/// <summary>
		/// Поле для bool-значения
		/// </summary>
		ControlBool = 4,

		/// <summary>
		/// Поле для даты
		/// </summary>
		ControlDateTime = 5,

		/// <summary>
		/// Поле для изображения
		/// </summary>
		ControlImage = 6,

		/// <summary>
		/// Поле для пеерчисления
		/// </summary>
		ControlEnum = 7,

		/// <summary>
		/// Поле для идентифкатора на другую сущность
		/// </summary>
		ControlGuid = 8
	}
}