﻿using CoreModels.Enums.Department;
using CoreModels.ModelsDepartment;
using ToolsModule.BindingModels;
using System;
using System.ComponentModel.DataAnnotations;

namespace DepartmentBusinessLogic.BindingModels
{
    /// <summary>
    /// Получение записи учебного плана
    /// </summary>
    public class AcademicPlanRecordGetBindingModel : GetBindingModel
	{
		public Guid? AcademicPlanId { get; set; }

		public Guid? DisciplineId { get; set; }

		public Semester? Semester { get; set; }
	}

	/// <summary>
	/// Сохранение записи учебного плана
	/// </summary>
	public class AcademicPlanRecordSetBindingModel : SetBindingModel, IAcademicPlanRecordModel
	{
		[Required(ErrorMessage = "required")]
		public Guid AcademicPlanId { get; set; }

		[Required(ErrorMessage = "required")]
		public Guid DisciplineId { get; set; }

		[Required(ErrorMessage = "required")]
		public bool InDepartment { get; set; }

		[Required(ErrorMessage = "required")]
		public Semester Semester { get; set; }

		[Required(ErrorMessage = "required")]
		public int Zet { get; set; }

		public Guid? AcademicPlanRecordParentId { get; set; }

		public bool IsParent { get; set; }

		public bool IsFacultative { get; set; }
    }
}