﻿using CoreModels.ModelsDepartment;
using ToolsModule.BindingModels;
using System;
using System.ComponentModel.DataAnnotations;

namespace DepartmentBusinessLogic.BindingModels
{
    /// <summary>
    /// Получение часов по норме времени для записи учебного плана
    /// </summary>
    public class AcademicPlanRecordTimeNormHourGetBindingModel : GetBindingModel
    {
        public Guid? AcademicPlanRecordId { get; set; }

        public Guid? TimeNormId { get; set; }
    }

    /// <summary>
    /// Сохранение часов по норме времени для записи учебного плана
    /// </summary>
    public class AcademicPlanRecordTimeNormHourSetBindingModel : SetBindingModel, IAcademicPlanRecordTimeNormHourModel
    {
        [Required(ErrorMessage = "required")]
        public Guid AcademicPlanRecordId { get; set; }

        [Required(ErrorMessage = "required")]
        public Guid TimeNormId { get; set; }

        [Required(ErrorMessage = "required")]
        public decimal PlanHours { get; set; }
    }
}