﻿using CoreModels.Enums.Department;
using CoreModels.ModelsDepartment;
using ToolsModule.BindingModels;
using System;
using System.ComponentModel.DataAnnotations;

namespace DepartmentBusinessLogic.BindingModels
{
    /// <summary>
    /// Получение аудитории
    /// </summary>
    public class ClassroomGetBindingModel : GetBindingModel
    {
        /// <summary>
        /// Используется для вывода в расписании 
        /// </summary>
        public bool? UseInSchedule { get; set; }

        /// <summary>
        /// Вывод аудиторий, закрепленных за сотрудником
        /// </summary>
        public Guid? EmployeeId { get; set; }
    }

    /// <summary>
    /// Сохранение аудитории
    /// </summary>
    public class ClassroomSetBindingModel : SetBindingModel, IClassroomModel
    {
        [Required(ErrorMessage = "required")]
        public string Number { get; set; }

        public string Title { get; set; }

        [Required(ErrorMessage = "required")]
        public Guid EmployeeId { get; set; }

        [Required(ErrorMessage = "required")]
        public ClassroomType ClassroomType { get; set; }

        [Required(ErrorMessage = "required")]
        public decimal Square { get; set; }

        [Required(ErrorMessage = "required")]
        public int Capacity { get; set; }

        public string SecurityCode { get; set; }

        public bool HaveProjector { get; set; }

        public string Description { get; set; }

        public byte[] Photo { get; set; }
    }
}