﻿using CoreModels.Enums.Department;
using CoreModels.ModelsDepartment;
using ToolsModule.BindingModels;
using System;
using System.ComponentModel.DataAnnotations;

namespace DepartmentBusinessLogic.BindingModels
{
    /// <summary>
    /// Получение направления обучения
    /// </summary>
    public class EducationDirectionGetBindingModel : GetBindingModel
    {
        /// <summary>
        /// Вывод направлений, закрепленных за преподавателем
        /// </summary>
        public Guid? LecturerId { get; set; }
    }

    /// <summary>
    /// Сохранение направления обучения
    /// </summary>
    public class EducationDirectionSetBindingModel : SetBindingModel, IEducationDirectionModel
    {
        [Required(ErrorMessage = "required")]
        public string Cipher { get; set; }

        [Required(ErrorMessage = "required")]
        public string ShortName { get; set; }

        [Required(ErrorMessage = "required")]
        public string Title { get; set; }

        public string Profile { get; set; }

        [Required(ErrorMessage = "required")]
        public EducationDirectionQualification Qualification { get; set; }

        [Required(ErrorMessage = "required")]
        public Guid LecturerId { get; set; }

        public string Description { get; set; }
    }
}