﻿using CoreModels.ModelsDepartment;
using ToolsModule.BindingModels;
using System;
using System.ComponentModel.DataAnnotations;

namespace DepartmentBusinessLogic.BindingModels
{
    /// <summary>
    /// Получение преподавателя
    /// </summary>
    public class LecturerGetBindingModel : GetBindingModel
    {
        public Guid? UserId { get; set; }

        public Guid? LecturerAcademicRankId { get; set; }

        public Guid? LecturerAcademicDegreeId { get; set; }
    }

    /// <summary>
    /// Сохранение преподавателя
    /// </summary>
    public class LecturerSetBindingModel : SetBindingModel, ILecturerModel
    {
        [Required(ErrorMessage = "required")]
        public Guid UserId { get; set; }

        public Guid? LecturerAcademicRankId { get; set; }

        public Guid? LecturerAcademicDegreeId { get; set; }

        [Required(ErrorMessage = "required")]
        public string LastName { get; set; }

        [Required(ErrorMessage = "required")]
        public string FirstName { get; set; }

        public string Patronymic { get; set; }

        public string Abbreviation { get; set; }

        [Required(ErrorMessage = "required")]
        public DateTime DateBirth { get; set; }

        [Required(ErrorMessage = "required")]
        public string Address { get; set; }

        [Required(ErrorMessage = "required")]
        public string Email { get; set; }

        [Required(ErrorMessage = "required")]
        public string MobileNumber { get; set; }

        public string HomeNumber { get; set; }

        public string Description { get; set; }

        public byte[] Photo { get; set; }

        public bool OnlyForPrivate { get; set; }

        [Required(ErrorMessage = "required")]
        public string GroupElectricalSafety { get; set; }
    }
}