﻿using CoreModels.ModelsDepartment;
using ToolsModule.BindingModels;
using System;
using System.ComponentModel.DataAnnotations;

namespace DepartmentBusinessLogic.BindingModels
{
    /// <summary>
    /// Получение связи преподавателя с должностью
    /// </summary>
    public class LecturerPostGetBindingModel : GetBindingModel
	{
		public Guid? LecturerId { get; set; }

		public Guid? PostId { get; set; }
	}

	/// <summary>
	/// Сохранение связи преподавателя с должностью
	/// </summary>
	public class LecturerPostSetBindingModel : SetBindingModel, ILecturerPostModel
	{
		[Required(ErrorMessage = "required")]
		public Guid LecturerId { get; set; }

		[Required(ErrorMessage = "required")]
		public Guid PostId { get; set; }

		[Required(ErrorMessage = "required")]
		public decimal Rate { get; set; }

		public bool IsInternalCombination { get; set; }

		public bool IsExternalCombination { get; set; }
	}
}