﻿using CoreModels.Enums.Department;
using CoreModels.ModelsDepartment;
using ToolsModule.BindingModels;
using System;
using System.ComponentModel.DataAnnotations;

namespace DepartmentBusinessLogic.BindingModels
{
    /// <summary>
    /// Получение приказа
    /// </summary>
    public class OrderGetBindingModel : GetBindingModel
	{
		public string OrderNumber { get; set; }

		public DateTime? OrderDate { get; set; }
	}

	/// <summary>
	/// Сохранение приказа
	/// </summary>
	public class OrderSetBindingModel : SetBindingModel, IOrderModel
	{
		[Required(ErrorMessage = "required")]
		public string OrderNumber { get; set; }

		[Required(ErrorMessage = "required")]
		public DateTime OrderDate { get; set; }

		[Required(ErrorMessage = "required")]
		public OrderType OrderType { get; set; }
	}
}