﻿using CoreModels.Enums.Department;
using CoreModels.ModelsDepartment;
using ToolsModule.BindingModels;
using System;
using System.ComponentModel.DataAnnotations;

namespace DepartmentBusinessLogic.BindingModels
{
    /// <summary>
    /// Получение записи приказа по студенту
    /// </summary>
    public class OrderStudentRecordGetBindingModel : GetBindingModel
	{
		public Guid? OrderId { get; set; }

		public Guid? StudentId { get; set; }

		public Guid? StudentGroupId { get; set; }

		public OrderStudentMoveType? OrderStudentMoveType { get; set; }
	}

	/// <summary>
	/// Сохранение записи приказа по студенту
	/// </summary>
	public class OrderStudentRecordSetBindingModel : SetBindingModel, IOrderStudentRecordModel
	{
		[Required(ErrorMessage = "required")]
		public Guid OrderId { get; set; }

		[Required(ErrorMessage = "required")]
		public Guid StudentId { get; set; }

		public Guid? StudentGroupFromId { get; set; }

		public Guid? StudentGroupToId { get; set; }

		[Required(ErrorMessage = "required")]
		public OrderStudentMoveType OrderStudentMoveType { get; set; }

		public string Info { get; set; }
	}
}