﻿using CoreModels.ModelsDepartment;
using ToolsModule.BindingModels;
using System;
using System.ComponentModel.DataAnnotations;

namespace DepartmentBusinessLogic.BindingModels
{
    /// <summary>
    /// Получение записи истории синхронизации приказов
    /// </summary>
    public class OrderSyncHistoryRecordGetBindingModel : GetBindingModel
	{
		public Guid? OrderSyncHistoryId { get; set; }
	}

	/// <summary>
	/// Сохранение записи истории синхронизации приказов
	/// </summary>
	public class OrderSyncHistoryRecordSetBindingModel : SetBindingModel, IOrderSyncHistoryRecordModel
	{
		[Required(ErrorMessage = "required")]
		public Guid OrderSyncHistoryId { get; set; }

		[Required(ErrorMessage = "required")]
		public string Information { get; set; }
	}
}