﻿using CoreModels.Enums.Department;
using CoreModels.ModelsDepartment;
using ToolsModule.BindingModels;
using System;
using System.ComponentModel.DataAnnotations;

namespace DepartmentBusinessLogic.BindingModels
{
    /// <summary>
    /// Получение студента
    /// </summary>
    public class StudentGetBindingModel : GetBindingModel
	{
		public Guid? UserId { get; set; }

		public Guid? StudentGroupId { get; set; }

		public StudentState? StudentState { get; set; }

		public string NumberOfBook { get; set; }
	}

	/// <summary>
	/// Сохранение студента
	/// </summary>
	public class StudentSetBindingModel : SetBindingModel, IStudentModel
	{
		[Required(ErrorMessage = "required")]
		public Guid UserId { get; set; }

		public Guid? StudentGroupId { get; set; }

		[Required(ErrorMessage = "required")]
		public string Iduniv { get; set; }

		[Required(ErrorMessage = "required")]
		public string NumberOfBook { get; set; }

		[Required(ErrorMessage = "required")]
		public string FirstName { get; set; }

		[Required(ErrorMessage = "required")]
		public string LastName { get; set; }

		public string Patronymic { get; set; }

		public string Email { get; set; }

		public string Description { get; set; }

		[Required(ErrorMessage = "required")]
		public StudentState StudentState { get; set; }

		public byte[] Photo { get; set; }

		public bool IsSteward { get; set; }
	}
}