﻿using CoreModels.Enums.Department;
using CoreModels.ModelsDepartment;
using ToolsModule.BindingModels;
using System;
using System.ComponentModel.DataAnnotations;

namespace DepartmentBusinessLogic.BindingModels
{
    /// <summary>
    /// Получение студенческой группы
    /// </summary>
    public class StudentGroupGetBindingModel : GetBindingModel
	{
		public Guid? EducationDirectionId { get; set; }

		public Guid? LecturerId { get; set; }
	}

	/// <summary>
	/// Сохранение студенческой группы
	/// </summary>
	public class StudentGroupSetBindingModel : SetBindingModel, IStudentGroupModel
	{
		[Required(ErrorMessage = "required")]
		public Guid EducationDirectionId { get; set; }

		[Required(ErrorMessage = "required")]
		public int GroupNumber { get; set; }

		[Required(ErrorMessage = "required")]
		public AcademicCourse AcademicCourse { get; set; }

		public Guid? LecturerId { get; set; }
	}
}