﻿using CoreModels.Enums.Department;
using CoreModels.ModelsDepartment;
using ToolsModule.BindingModels;
using System;
using System.ComponentModel.DataAnnotations;

namespace DepartmentBusinessLogic.BindingModels
{
    /// <summary>
    /// Получение нормы времени
    /// </summary>
	public class TimeNormGetBindingModel : GetBindingModel
    {
        public Guid? DisciplineBlockId { get; set; }
    }

    /// <summary>
    /// Сохранение нормы времени
    /// </summary>
    public class TimeNormSetBindingModel : SetBindingModel, ITimeNormModel
    {
        [Required(ErrorMessage = "required")]
        public Guid DisciplineBlockId { get; set; }

        [Required(ErrorMessage = "required")]
        public string TimeNormName { get; set; }

        [Required(ErrorMessage = "required")]
        public string TimeNormShortName { get; set; }

        [Required(ErrorMessage = "required")]
        public int TimeNormOrder { get; set; }

        public EducationDirectionQualification? TimeNormEducationDirectionQualification { get; set; }

        [Required(ErrorMessage = "required")]
        public string KindOfLoadName { get; set; }

        public string KindOfLoadAttributeName { get; set; }

        public string KindOfLoadBlueAsteriskName { get; set; }

        public string KindOfLoadBlueAsteriskAttributeName { get; set; }

        public string KindOfLoadBlueAsteriskPracticName { get; set; }

        public bool UseInLearningProgress { get; set; }

        public bool UseInSite { get; set; }

        /// <summary>
        /// Код вида работ в справочнике видов работ в новой версии планов, чтобы потом искать работу в строках плана
        /// </summary>
        public string KindOfLoadBlueAsteriskCode { get; set; }

        /// <summary>
        /// Код вида практики в справочнике видов практик в новой версии планов, чтобы потом искать практику в строках плана
        /// </summary>
        public string KindOfLoadBlueAsteriskPracticCode { get; set; }
    }
}