﻿using CoreModels.ModelsDepartment;
using ToolsModule.Attributes;
using ToolsModule.Enums;
using ToolsModule.ViewModels;
using System;

namespace DepartmentBusinessLogic.ViewModels
{
	/// <summary>
	/// Список учбеных планов
	/// </summary>
	public class AcademicPlanListViewModel : ListViewModel<AcademicPlanViewModel> { }

	/// <summary>
	/// Элемент учебного плана
	/// </summary>
	[ViewModelControlElementClass(HaveDependenceEntities = true, Width = 1200, Height = 800)]
	[ViewModelControlElementDependenceEntity(Title = "Записи плана", Order = 1, ParentPropertyName = "AcademicPlanId",
		ControlTypeObject = "DepartmentWindowsDesktop.EntityControls.ControlAcademicPlanRecordList, DepartmentWindowsDesktop")]
	public class AcademicPlanViewModel : ElementViewModel, IAcademicPlanModel
	{
		[ViewModelControlElementProperty("Направление", ControlType.ControlGuid, MustHaveValue = false, ReadOnly = false, ControlTypeObject = "DepartmentWindowsDesktop.EntityControls.ControlEducationDirectionList, DepartmentWindowsDesktop")]
		public Guid? EducationDirectionId { get; set; }

		[ViewModelControlListProperty("Направление")]
		[MapConfiguration("EducationDirection.Cipher", IsDifficle = true)]
		public string EducationDirectionCipher { get; set; }

		[ViewModelControlListProperty("Профиль")]
		[MapConfiguration("EducationDirection.Profile", IsDifficle = true)]
		public string EducationDirectionProfile { get; set; }

		[ViewModelControlListProperty("Дата начала", ColumnWidth = 120)]
		[ViewModelControlElementProperty("Дата начала", ControlType.ControlInt, MustHaveValue = true)]
		public int YearEntrance { get; set; }

		[ViewModelControlListProperty("Дата окончания", ColumnWidth = 120)]
		[ViewModelControlElementProperty("Дата окончания", ControlType.ControlInt, MustHaveValue = true)]
		public int YearFinish { get; set; }
	}
}