﻿using CoreModels.ModelsDepartment;
using ToolsModule.Attributes;
using ToolsModule.Enums;
using ToolsModule.ViewModels;

namespace DepartmentBusinessLogic.ViewModels
{
    /// <summary>
    /// Список блоков дисциплин
    /// </summary>
    public class DisciplineBlockListViewModel : ListViewModel<DisciplineBlockViewModel> { }

	/// <summary>
	/// Элемент блок дисциплины
	/// </summary>
	[ViewModelControlElementClass(HaveDependenceEntities = true, Width = 800, Height = 500)]
	[ViewModelControlElementDependenceEntity(Title = "Дисципилны", Order = 1, ParentPropertyName = "DisciplineBlockId",
		ControlTypeObject = "DepartmentWindowsDesktop.EntityControls.ControlDisciplineList, DepartmentWindowsDesktop")]
	[ViewModelControlElementDependenceEntity(Title = "Нормы времени", Order = 1, ParentPropertyName = "DisciplineBlockId",
		ControlTypeObject = "DepartmentWindowsDesktop.EntityControls.ControlTimeNormList, DepartmentWindowsDesktop")]
	public class DisciplineBlockViewModel : ElementViewModel, IDisciplineBlockModel
	{
		[ViewModelControlListProperty("Название блока")]
		[ViewModelControlElementProperty("Название блока", ControlType.ControlString, MustHaveValue = true)]
		public string Title { get; set; }

		[ViewModelControlElementProperty("Используется для группровки в расчетах", ControlType.ControlBool, MustHaveValue = true)]
		public bool DisciplineBlockUseForGrouping { get; set; }

		[ViewModelControlListProperty("Порядок", ColumnWidth = 100)]
		[ViewModelControlElementProperty("Порядок", ControlType.ControlInt, MustHaveValue = true)]
		public int DisciplineBlockOrder { get; set; }

		[ViewModelControlElementProperty("Назв. в планах", ControlType.ControlString)]
		public string DisciplineBlockBlueAsteriskName { get; set; }
	}
}
