﻿using CoreModels.ModelsDepartment;
using ToolsModule.Attributes;
using ToolsModule.Enums;
using ToolsModule.ViewModels;
using System;

namespace DepartmentBusinessLogic.ViewModels
{
    /// <summary>
    /// Список дисциплин
    /// </summary>
    public class DisciplineListViewModel : ListViewModel<DisciplineViewModel> { }

	/// <summary>
	/// Элемент дисциплина
	/// </summary>
	[ViewModelControlElementClass(HaveDependenceEntities = true, Width = 800, Height = 500)]
	[ViewModelControlElementDependenceEntity(Title = "Записи учебного плана", Order = 1, ParentPropertyName = "DisciplineId",
		ControlTypeObject = "DepartmentWindowsDesktop.EntityControls.ControlAcademicPlanRecordList, DepartmentWindowsDesktop")]
	public class DisciplineViewModel : ElementViewModel, IDisciplineModel
	{
		[ViewModelControlElementProperty("Блок дисциплин", ControlType.ControlGuid, MustHaveValue = true, ReadOnly = false, ControlTypeObject = "DepartmentWindowsDesktop.EntityControls.ControlDisciplineBlockList, DepartmentWindowsDesktop")]
		public Guid DisciplineBlockId { get; set; }

		[ViewModelControlListProperty("Название дисциплины")]
		[ViewModelControlElementProperty("Название дисциплины", ControlType.ControlString, MustHaveValue = true)]
		public string DisciplineName { get; set; }

		[ViewModelControlListProperty("Краткое название дисциплины")]
		[ViewModelControlElementProperty("Краткое нисциплины", ControlType.ControlString, MustHaveValue = true)]
		public string DisciplineShortName { get; set; }

		[ViewModelControlListProperty("Описание")]
		[ViewModelControlElementProperty("Описание", ControlType.ControlText, Height = 200, MustHaveValue = true)]
		public string Description { get; set; }

		[ViewModelControlElementProperty("Название в планах", ControlType.ControlString)]
		public string DisciplineBlueAsteriskName { get; set; }
	}
}