﻿using CoreModels.ModelsDepartment;
using ToolsModule.Attributes;
using ToolsModule.Enums;
using ToolsModule.ViewModels;

namespace DepartmentBusinessLogic.ViewModels
{
    /// <summary>
    /// Список должностей преподавателей
    /// </summary>
    public class LecturerAcademicDegreeListViewModel : ListViewModel<LecturerAcademicDegreeViewModel> { }

	/// <summary>
	/// Элемент должности преподавателей
	/// </summary>
	[ViewModelControlElementClass(HaveDependenceEntities = true, Width = 800, Height = 500)]
	[ViewModelControlElementDependenceEntity(Title = "Преподаватели", Order = 1, ParentPropertyName = "LecturerAcademicDegreeId",
		ControlTypeObject = "DepartmentWindowsDesktop.EntityControls.ControlLecturerList, DepartmentWindowsDesktop")]
	public class LecturerAcademicDegreeViewModel : ElementViewModel, ILecturerAcademicDegreeModel
	{
		[ViewModelControlListProperty("Ученая степень")]
		[ViewModelControlElementProperty("Ученая степень", ControlType.ControlString, MustHaveValue = true)]
		public string LecturerAcademicDegreeName { get; set; }

		[ViewModelControlListProperty("Описание")]
		[ViewModelControlElementProperty("Описание", ControlType.ControlString)]
		public string Description { get; set; }

		[ViewModelControlListProperty("Порядок", ColumnWidth = 100)]
		[ViewModelControlElementProperty("Порядок", ControlType.ControlInt, MustHaveValue = true)]
		public int Order { get; set; }
	}
}