﻿using CoreModels.Enums.Department;
using CoreModels.ModelsDepartment;
using ToolsModule.Attributes;
using ToolsModule.Enums;
using ToolsModule.ViewModels;
using System;

namespace DepartmentBusinessLogic.ViewModels
{
    /// <summary>
    /// Список приказов
    /// </summary>
    public class OrderStudentRecordListViewModel : ListViewModel<OrderStudentRecordViewModel> { }

	/// <summary>
	/// Элемент приказа
	/// </summary>
	[ViewModelControlElementClass(HaveDependenceEntities = false)]
	public class OrderStudentRecordViewModel : ElementViewModel, IOrderStudentRecordModel
	{
		[ViewModelControlElementProperty("Приказ", ControlType.ControlGuid, MustHaveValue = true, ReadOnly = false, ControlTypeObject = "DepartmentWindowsDesktop.EntityControls.ControlOrderList, DepartmentWindowsDesktop")]
		public Guid OrderId { get; set; }

		[ViewModelControlElementProperty("Студент", ControlType.ControlGuid, MustHaveValue = true, ReadOnly = false, ControlTypeObject = "DepartmentWindowsDesktop.EntityControls.ControlStudentList, DepartmentWindowsDesktop")]
		public Guid StudentId { get; set; }

		[ViewModelControlElementProperty("Из группы", ControlType.ControlGuid, MustHaveValue = false, ReadOnly = false, ControlTypeObject = "DepartmentWindowsDesktop.EntityControls.ControlStudentGroupList, DepartmentWindowsDesktop")]
		public Guid? StudentGroupFromId { get; set; }

		[ViewModelControlElementProperty("В группу", ControlType.ControlGuid, MustHaveValue = false, ReadOnly = false, ControlTypeObject = "DepartmentWindowsDesktop.EntityControls.ControlStudentGroupList, DepartmentWindowsDesktop")]
		public Guid? StudentGroupToId { get; set; }

		[ViewModelControlElementProperty("Тип приказа", ControlType.ControlEnum, MustHaveValue = true)]
		public OrderStudentMoveType OrderStudentMoveType { get; set; }

		[ViewModelControlListProperty("Тип приказа")]
		public string OrderStudentMoveTypeTitle => OrderStudentMoveType.ToString("G");

		[ViewModelControlElementProperty("Тип приказа", ControlType.ControlText, Height = 200)]
		public string Info { get; set; }

        public override string ToString() => $"";
	}
}