﻿using CoreModels.ModelsDepartment;
using ToolsModule.Attributes;
using ToolsModule.Enums;
using ToolsModule.ViewModels;
using System;

namespace DepartmentBusinessLogic.ViewModels
{
    /// <summary>
    /// Список историй синхронизации приказов
    /// </summary>
    public class OrderSyncHistoryListViewModel : ListViewModel<OrderSyncHistoryViewModel> { }

	/// <summary>
	/// Элемент история синхронизации приказов
	/// </summary>
	[ViewModelControlElementClass(HaveDependenceEntities = true, Width = 800, Height = 500)]
	[ViewModelControlElementDependenceEntity(Title = "Записи", Order = 1, ParentPropertyName = "OrderSyncHistoryId",
		ControlTypeObject = "DepartmentWindowsDesktop.EntityControls.ControlOrderSyncHistoryRecordList, DepartmentWindowsDesktop")]
	public class OrderSyncHistoryViewModel : ElementViewModel, IOrderSyncHistoryModel
	{
		[ViewModelControlElementProperty("Дата", ControlType.ControlDateTime, MustHaveValue = true, ReadOnly = true)]
		public DateTime SyncDate { get; set; }

		[ViewModelControlListProperty("Дата")]
		public string SyncDateTitle => $"Синхронизация данных от {SyncDate.ToString("dd.MM.yyyy HH:mm")}";
	}
}