﻿using CoreModels.Enums.Department;
using DepartmentBusinessLogic.BindingModels;
using DepartmentBusinessLogic.BusinessLogics;
using DepartmentBusinessLogic.ViewModels;
using ToolsDesktop.Controls;
using ToolsDesktop.Enums;
using ToolsDesktop.Interfaces;
using ToolsDesktop.Models;
using ToolsModule.Enums;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;

namespace DepartmentWindowsDesktop.EntityControls
{
    /// <summary>
    /// Реализация контрола для записей учебного плана
    /// </summary>
    public partial class ControlAcademicPlanRecordList :
		GenericControlEntityList<AcademicPlanRecordGetBindingModel, AcademicPlanRecordSetBindingModel, AcademicPlanRecordListViewModel, AcademicPlanRecordViewModel, AcademicPlanRecordBusinessLogic>,
		IGenericControlEntityList
	{
		public ControlAcademicPlanRecordList()
		{
			InitializeComponent();
			Title = "Записи учебного плана";
			ControlId = new Guid("6513cc00-4ac1-4420-b941-dcd199faecad");
			AccessOperation = AccessOperation.Аудитории;
			ControlViewEntityElement = new ControlAcademicPlanRecordElement();
			_genericControlViewEntityList = this;
		}

		public IControl GetInstanceGenericControl() => new ControlAcademicPlanRecordList() { ControlId = Guid.NewGuid() };

		public ControlViewEntityListConfiguration GetConfigControl() => new()
		{
			PaginationOn = true,
			PageNamesForPagination = Enum.GetValues(typeof(Semester)).OfType<Semester>().ToList().Select(x =>
																					new PageNamesForPaginationModel
																					{
																						Key = x,
																						Value = x.ToString()
																					})?.ToList(),
			ParentPropertyName = "Semester",
			HideToolStripButton = new List<ToolStripButtonListNames>
			{
				ToolStripButtonListNames.toolStripButtonSearch
			}
		};
	}
}