﻿using DepartmentBusinessLogic.BindingModels;
using DepartmentBusinessLogic.BusinessLogics;
using DepartmentBusinessLogic.ViewModels;
using ToolsDesktop.Controls;
using ToolsDesktop.Enums;
using ToolsDesktop.Interfaces;
using ToolsDesktop.Models;
using ToolsModule.Enums;
using System;
using System.Collections.Generic;

namespace DepartmentWindowsDesktop.EntityControls
{
	/// <summary>
	/// Реализация контрола для списка направлений обучений
	/// </summary>
	public partial class ControlEducationDirectionList :
		GenericControlEntityList<EducationDirectionGetBindingModel, EducationDirectionSetBindingModel, EducationDirectionListViewModel, EducationDirectionViewModel, EducationDirectionBusinessLogic>,
		IGenericControlEntityList
	{
		public ControlEducationDirectionList()
		{
			InitializeComponent();
			Title = "Направления Обучений";
			ControlId = new Guid("9d6eee16-e84c-4483-a744-6568de11c6d9");
			AccessOperation = AccessOperation.НаправленияОбучений;
			ControlViewEntityElement = new ControlEducationDirectionElement();
			_genericControlViewEntityList = this;
		}

		public IControl GetInstanceGenericControl() => new ControlEducationDirectionList() { ControlId = Guid.NewGuid() };

		public ControlViewEntityListConfiguration GetConfigControl() => new()
		{
			PaginationOn = false,
			HideToolStripButton = new List<ToolStripButtonListNames>
			{
				ToolStripButtonListNames.toolStripButtonSearch
			}
		};
	}
}