﻿using DepartmentBusinessLogic.BindingModels;
using DepartmentBusinessLogic.BusinessLogics;
using DepartmentBusinessLogic.ViewModels;
using ToolsDesktop.Controls;
using ToolsDesktop.Enums;
using ToolsDesktop.Interfaces;
using ToolsDesktop.Models;
using ToolsModule.Enums;
using System;
using System.Collections.Generic;

namespace DepartmentWindowsDesktop.EntityControls
{
	/// <summary>
	/// Реализация контрола для списка ученых званий
	/// </summary>
	public partial class ControlLecturerAcademicRankList :
		GenericControlEntityList<LecturerAcademicRankGetBindingModel, LecturerAcademicRankSetBindingModel, LecturerAcademicRankListViewModel, LecturerAcademicRankViewModel, LecturerAcademicRankBusinessLogic>,
		IGenericControlEntityList
	{
		public ControlLecturerAcademicRankList()
		{
			InitializeComponent();
			Title = "Ученые звания преподавателей";
			ControlId = new Guid("f38651c5-6717-49ca-bd3f-2556bb90a7a0");
			AccessOperation = AccessOperation.Преподаватели;
			ControlViewEntityElement = new ControlLecturerAcademicRankElement();
			_genericControlViewEntityList = this;
		}

		public IControl GetInstanceGenericControl() => new ControlLecturerAcademicRankList() { ControlId = Guid.NewGuid() };

		public ControlViewEntityListConfiguration GetConfigControl() => new()
		{
			PaginationOn = false,
			HideToolStripButton = new List<ToolStripButtonListNames>
			{
				ToolStripButtonListNames.toolStripButtonSearch
			}
		};
	}
}