﻿using DepartmentBusinessLogic.BindingModels;
using DepartmentBusinessLogic.BusinessLogics;
using DepartmentBusinessLogic.ViewModels;
using ToolsDesktop.Controls;
using ToolsDesktop.Enums;
using ToolsDesktop.Interfaces;
using ToolsDesktop.Models;
using ToolsModule.Enums;
using System;
using System.Collections.Generic;

namespace DepartmentWindowsDesktop.EntityControls
{
	/// <summary>
	/// Реализация контрола для списка записей истории синхронизации приказов
	/// </summary>
	public partial class ControlOrderSyncHistoryRecordList :
		GenericControlEntityList<OrderSyncHistoryRecordGetBindingModel, OrderSyncHistoryRecordSetBindingModel, OrderSyncHistoryRecordListViewModel, OrderSyncHistoryRecordViewModel, OrderSyncHistoryRecordBusinessLogic>,
		IGenericControlEntityList
	{
		public ControlOrderSyncHistoryRecordList()
		{
			InitializeComponent();
			Title = "Записи Синхронизации Приказов";
			ControlId = new Guid("8d18e9fa-f056-47c8-b83d-f06f6bf553c2");
			AccessOperation = AccessOperation.СинхронизацияПриказов;
			ControlViewEntityElement = new ControlOrderSyncHistoryRecordElement();
			_genericControlViewEntityList = this;
		}

		public IControl GetInstanceGenericControl() => new ControlOrderSyncHistoryRecordList() { ControlId = Guid.NewGuid() };

		public ControlViewEntityListConfiguration GetConfigControl() => new()
		{
			PaginationOn = false,
			HideToolStripButton = new List<ToolStripButtonListNames>
			{
				ToolStripButtonListNames.toolStripButtonAdd,
				ToolStripButtonListNames.toolStripButtonUpd,
				ToolStripButtonListNames.toolStripButtonDel,
				ToolStripButtonListNames.toolStripButtonSearch
			}
		};
	}
}