﻿using DepartmentBusinessLogic.BindingModels;
using DepartmentBusinessLogic.BusinessLogics;
using DepartmentBusinessLogic.ViewModels;
using ToolsDesktop.Controls;
using ToolsDesktop.Enums;
using ToolsDesktop.Interfaces;
using ToolsDesktop.Models;
using ToolsModule.Enums;
using System;
using System.Collections.Generic;

namespace DepartmentWindowsDesktop.EntityControls
{
	/// <summary>
	/// Реализация контрола для списка норм времени
	/// </summary>
	public partial class ControlTimeNormList :
		GenericControlEntityList<TimeNormGetBindingModel, TimeNormSetBindingModel, TimeNormListViewModel, TimeNormViewModel, TimeNormBusinessLogic>,
		IGenericControlEntityList
	{
		public ControlTimeNormList()
		{
			InitializeComponent();
			Title = "Нормы времени";
			ControlId = new Guid("973e071f-b47a-4eef-bec6-6cbc63ecb5f5");
			AccessOperation = AccessOperation.НормыВремени;
			ControlViewEntityElement = new ControlTimeNormElement();
			_genericControlViewEntityList = this;
		}

		public IControl GetInstanceGenericControl() => new ControlTimeNormList() { ControlId = Guid.NewGuid() };

		public ControlViewEntityListConfiguration GetConfigControl() => new()
		{
			PaginationOn = false,
			HideToolStripButton = new List<ToolStripButtonListNames>
			{
				ToolStripButtonListNames.toolStripButtonSearch
			}
		};
	}
}