﻿using SecurityBusinessLogic.BusinessLogics;
using SecurityBusinessLogic.BusinessLogics.GenericBusinessLogic;
using SecurityContract.Logics;
using SecurityContract.Logics.IGenericEntityLogic;
using ToolsModule.BusinessLogics;
using ToolsModule.Interfaces;

namespace SecurityBusinessLogic
{
    public class SecurityLogicDependencyRegistration : IImplementationExtension
    {
        public void RegisterServices()
		{
			DependencyManager.Instance.RegisterType<IAccessLogic, AccessBusinessLogic>();
			DependencyManager.Instance.RegisterType<IEnviromentSettingLogic, EnviromentSettingBusinessLogic>();
			DependencyManager.Instance.RegisterType<IRoleLogic, RoleBusinessLogic>();
			DependencyManager.Instance.RegisterType<IUserLogic, UserBusinessLogic>();
			DependencyManager.Instance.RegisterType<IUserRoleLogic, UserRoleBusinessLogic>();

			DependencyManager.Instance.RegisterType<IBackupLogic, BackupBusinessLogic>();
			DependencyManager.Instance.RegisterType<ISynchronizationLogic, SynchronizationBusinessLogic>();
		}
    }
}