﻿using SecurityContract.BindingModels;
using SecurityContract.ViewModels;
using ToolsModule.Interfaces;

namespace SecurityContract.Logics.IGenericEntityLogic
{
    /// <summary>
    /// Логика работы с пользователями
    /// </summary>
    public interface IUserLogic : IGenericEntityLogic<UserGetBindingModel, UserSetBindingModel, UserListViewModel, UserViewModel>
	{
        /// <summary>
        /// Метод получения или создания пользователя для студента/сотрудника/преподавателя
        /// </summary>
        /// <param name="model"></param>
        /// <param name="password"></param>
        /// <returns></returns>
		UserViewModel GetOrCreateUser(UserGetBindingModel model, string password);
	}
}