﻿using CoreModels.ModelsSecurity;
using ToolsModule.Attributes;
using ToolsModule.Enums;
using ToolsModule.ViewModels;

namespace SecurityContract.ViewModels
{
    /// <summary>
    /// Список общих настроек системы
    /// </summary>
    public class EnviromentSettingListViewModel : ListViewModel<EnviromentSettingViewModel> { }

	/// <summary>
	/// Элемент общих настроек системы
	/// </summary>
	[ViewModelControlElementClass()]
	public class EnviromentSettingViewModel : ElementViewModel, IEnviromentSettingModel
	{
		[ViewModelControlListProperty("Ключ")]
		[ViewModelControlElementProperty("Ключ", ControlType.ControlString, MustHaveValue = true, ReadOnly = true)]
		public string Key { get; set; }

		[ViewModelControlListProperty("Значение")]
		[ViewModelControlElementProperty("Значение", ControlType.ControlString, MustHaveValue = true)]
		public string Value { get; set; }

		[ViewModelControlListProperty("Описание")]
		[ViewModelControlElementProperty("Описание", ControlType.ControlText, Height = 200)]
		public string Description { get; set; }
	}
}