﻿using CoreModels.ModelsSecurity;
using ToolsModule.Attributes;
using ToolsModule.Enums;
using ToolsModule.ViewModels;

namespace SecurityContract.ViewModels
{
    /// <summary>
    /// Список ролей
    /// </summary>
    public class RoleListViewModel : ListViewModel<RoleViewModel> { }

	/// <summary>
	/// Элемент ролей
	/// </summary>
	[ViewModelControlElementClass(HaveDependenceEntities = true, Width = 800, Height = 500)]
	[ViewModelControlElementDependenceEntity(Title = "Доступы", Order = 1, ParentPropertyName = "RoleId", 
		ControlTypeObject = "SecurityWindowsDesktop.EntityControls.ControlAccessList, SecurityWindowsDesktop")]
	[ViewModelControlElementDependenceEntity(Title = "Пользователи", Order = 2, ParentPropertyName = "RoleId",
		ControlTypeObject = "SecurityWindowsDesktop.EntityControls.ControlUserRoleList, SecurityWindowsDesktop")]
	public class RoleViewModel : ElementViewModel, IRoleModel
	{
		[ViewModelControlListProperty("Название роли")]
		[ViewModelControlElementProperty("Название роли", ControlType.ControlString, MustHaveValue = true)]
		public string RoleName { get; set; }

		[ViewModelControlListProperty("Приоритет", ColumnWidth = 100)]
		[ViewModelControlElementProperty("Приоритет", ControlType.ControlInt, MustHaveValue = true)]
		public int RolePriority { get; set; }
	}
}