﻿using SecurityContract.Interfaces;
using SecurityContract.Interfaces.IGenericEntityService;
using SecurityDatabaseImplementation.Implementations;
using ToolsModule.BusinessLogics;
using ToolsModule.Interfaces;

namespace SecurityDatabaseImplementation
{
    public class SecurityImplementationExtensions : IImplementationExtension
	{
		public void RegisterServices()
		{
			DependencyManager.Instance.RegisterType<IAccessService, AccessService>();
			DependencyManager.Instance.RegisterType<IEnviromentSettingService, EnviromentSettingService>();
			DependencyManager.Instance.RegisterType<IRoleService, RoleService>();
			DependencyManager.Instance.RegisterType<IUserService, UserService>();
			DependencyManager.Instance.RegisterType<IUserRoleService, UserRoleService>();

			DependencyManager.Instance.RegisterType<IBackupService, BackupJsonContractService>();
			DependencyManager.Instance.RegisterType<ISynchronizationService, SynchronizationService>();
		}
	}
}