﻿using SecurityContract.BindingModels;
using SecurityContract.Logics.IGenericEntityLogic;
using SecurityContract.ViewModels;
using System;
using System.Collections.Generic;
using ToolsDesktop.Controls;
using ToolsDesktop.Enums;
using ToolsDesktop.Interfaces;
using ToolsDesktop.Models;
using ToolsModule.Enums;

namespace SecurityWindowsDesktop.EntityControls
{
    /// <summary>
    /// Реализация контрола для списка настроек среды
    /// </summary>
    public partial class ControlEnviromentSettingList : 
		GenericControlEntityList<EnviromentSettingGetBindingModel, EnviromentSettingSetBindingModel, EnviromentSettingListViewModel, EnviromentSettingViewModel, IEnviromentSettingLogic>,
		IGenericControlEntityList
	{
		public ControlEnviromentSettingList()
		{
			InitializeComponent();
			Title = "Настройки Среды";
			ControlId = new Guid("b3865c23-b1db-475b-b95c-aa51edc60388");
			AccessOperation = AccessOperation.НастройкиСреды;
			ControlViewEntityElement = new ControlEnviromentSettingElement();
			_genericControlViewEntityList = this;
		}

		public IControl GetInstanceGenericControl() => new ControlEnviromentSettingList() { ControlId = Guid.NewGuid() };

		public ControlViewEntityListConfiguration GetConfigControl() => new()
		{
			PaginationOn = false,
			HideToolStripButton = new List<ToolStripButtonListNames> 
			{
				ToolStripButtonListNames.toolStripButtonAdd,
				ToolStripButtonListNames.toolStripButtonSearch
			}
		};
	}
}